## ros-foxy-maliput-sparse 0.2.3

=== CMakeLists.txt ===
##############################################################################
# Project
##############################################################################

cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
project(maliput_sparse LANGUAGES C CXX VERSION 3.0.0)

##############################################################################
# Find 3rd Party Packages
##############################################################################

message(STATUS "\n\n====== Finding 3rd Party Packages ======\n")

find_package(ament_cmake REQUIRED)
find_package(maliput REQUIRED)

##############################################################################
# Project Configuration
##############################################################################

message(STATUS "\n\n========= Project Configuration ========\n")

set(BUILD_SHARED_LIBS true)

include(${PROJECT_SOURCE_DIR}/cmake/DefaultCFlags.cmake)
include(${PROJECT_SOURCE_DIR}/cmake/SanitizersConfig.cmake)

ament_environment_hooks(
  "${ament_cmake_package_templates_ENVIRONMENT_HOOK_LIBRARY_PATH}"
)

##############################################################################
# Docs
##############################################################################

if(BUILD_DOCS)
  message(STATUS "Doxygen generation - Enabled")
  find_package(ament_cmake_doxygen REQUIRED)
    ament_doxygen_generate(doxygen_maliput_sparse
      CONFIG_OVERLAY doc/Doxyfile.overlay.in
      TEST_ON_WARNS
    )
  add_definitions(-DBUILD_DOCS)
else()
  message(STATUS "Doxygen generation - Disabled")
endif()

##############################################################################
# Sources
##############################################################################
add_subdirectory(src)

##############################################################################
# Tests
##############################################################################

if(BUILD_TESTING)
  find_package(ament_cmake_clang_format REQUIRED)
  enable_testing()
  add_subdirectory(test)
  ament_clang_format(CONFIG_FILE ${CMAKE_CURRENT_SOURCE_DIR}/.clang-format)
endif()

##############################################################################
# Export
##############################################################################

install(
  DIRECTORY include/
  DESTINATION include
)

ament_export_include_directories(include)
ament_export_dependencies(ament_cmake)
ament_export_targets(${PROJECT_NAME}-targets HAS_LIBRARY_TARGET)
ament_package()

=== src/CMakeLists.txt ===
add_subdirectory(base)
add_subdirectory(builder)
add_subdirectory(geometry)
add_subdirectory(loader)
add_subdirectory(parser)
add_subdirectory(test_utilities)

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)
find_package(ament_cmake_gmock REQUIRED)

add_subdirectory(base)
add_subdirectory(builder)
add_subdirectory(geometry)
add_subdirectory(parser)

=== src/base/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

set(BASE_SOURCES
  lane.cc
  road_geometry.cc
)

add_library(base ${BASE_SOURCES})

add_library(maliput_sparse::base ALIAS base)

set_target_properties(base
  PROPERTIES
    OUTPUT_NAME maliput_sparse_base
)

target_include_directories(base
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(base
  PUBLIC
  maliput::api
  maliput::common
  maliput::geometry_base
  maliput::math
)

##############################################################################
# Export
##############################################################################

include(CMakePackageConfigHelpers)

install(
  TARGETS base
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== src/builder/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

set(BUILDER_SOURCES
  builder.cc
)

add_library(builder ${BUILDER_SOURCES})

add_library(maliput_sparse::builder ALIAS builder)

set_target_properties(builder
  PROPERTIES
    OUTPUT_NAME maliput_sparse_builder
)

target_include_directories(builder
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(builder
  PUBLIC
  maliput::api
  maliput::common
  maliput::geometry_base
  maliput::math
  maliput_sparse::base
  maliput_sparse::geometry
)

##############################################################################
# Export
##############################################################################

install(TARGETS builder
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

=== src/geometry/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

set(GEOMETRY_SOURCES
  line_string.cc
  lane_geometry.cc
  utility/geometry.cc
)

add_library(geometry ${GEOMETRY_SOURCES})

add_library(maliput_sparse::geometry ALIAS geometry)

set_target_properties(geometry
  PROPERTIES
    OUTPUT_NAME maliput_sparse_geometry
)

target_include_directories(geometry
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(geometry
  PUBLIC
    maliput::common
    maliput::math
)

##############################################################################
# Export
##############################################################################

include(CMakePackageConfigHelpers)

install(
  TARGETS geometry
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== src/loader/CMakeLists.txt ===
##############################################################################
# Sources
##############################################################################

set(LOADER_SOURCES
  builder_configuration.cc
  road_geometry_loader.cc
  road_network_loader.cc
)

add_library(loader ${LOADER_SOURCES})

add_library(maliput_sparse::loader ALIAS loader)

set_target_properties(loader
  PROPERTIES
    OUTPUT_NAME maliput_sparse_loader
)

target_include_directories(loader
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(loader
  PUBLIC
  maliput::api
  maliput::base
  maliput::common
  maliput_sparse::builder
)

##############################################################################
# Export
##############################################################################

install(TARGETS loader
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

=== src/parser/CMakeLists.txt ===
##############################################################################
# parser
##############################################################################
add_library(parser
  connection.cc
  lane.cc
  validator.cc
)

add_library(maliput_sparse::parser ALIAS parser)
set_target_properties(parser
  PROPERTIES
    OUTPUT_NAME maliput_sparse_parser
)

target_include_directories(
    parser
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:include>
)

target_link_libraries(parser
   PRIVATE
    maliput::common
    maliput_sparse::geometry
)

install(TARGETS parser
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

=== src/test_utilities/CMakeLists.txt ===
##############################################################################
# osm
##############################################################################

if(BUILD_TESTING)

add_library(test_utilities
  maliput_sparse_types_compare.cc
)
add_library(maliput_sparse::test_utilities ALIAS test_utilities)
set_target_properties(test_utilities
  PROPERTIES
    OUTPUT_NAME maliput_sparse_test_utilities
)

target_include_directories(
  test_utilities
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

target_link_libraries(test_utilities
   PRIVATE
    maliput::test_utilities
    maliput_sparse::geometry
)

install(TARGETS test_utilities
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

endif()

=== test/base/CMakeLists.txt ===
ament_add_gtest(lane_test lane_test.cc)
ament_add_gtest(road_geometry_test road_geometry_test.cc)

macro(add_dependencies_to_test target)
if (TARGET ${target})

      target_include_directories(${target}
        PRIVATE
          ${CMAKE_CURRENT_SOURCE_DIR}
          ${PROJECT_SOURCE_DIR}/include
          ${PROJECT_SOURCE_DIR}/src
          ${PROJECT_SOURCE_DIR}/test
      )

      target_link_libraries(${target}
          maliput::api
          maliput::common
          maliput::geometry_base
          maliput::math
          maliput::test_utilities
          maliput_sparse::base
          maliput_sparse::builder
          maliput_sparse::geometry
      )

    endif()
endmacro()

add_dependencies_to_test(lane_test)
add_dependencies_to_test(road_geometry_test)

=== test/builder/CMakeLists.txt ===
ament_add_gtest(builder_test builder_test.cc)

macro(add_dependencies_to_test target)
if (TARGET ${target})

      target_include_directories(${target}
        PRIVATE
          ${PROJECT_SOURCE_DIR}/include
          ${CMAKE_CURRENT_SOURCE_DIR}
          ${PROJECT_SOURCE_DIR}/test
      )

      target_link_libraries(${target}
          maliput::api
          maliput::common
          maliput::geometry_base
          maliput::math
          maliput::test_utilities
          maliput_sparse::base
          maliput_sparse::builder
          maliput_sparse::geometry
      )

    endif()
endmacro()

add_dependencies_to_test(builder_test)

=== test/geometry/CMakeLists.txt ===
ament_add_gtest(lane_geometry_test lane_geometry_test.cc)
ament_add_gtest(line_string_test line_string_test.cc)
ament_add_gtest(geometry_test utility/geometry_test.cc)

macro(add_dependencies_to_test target)
if (TARGET ${target})

      target_include_directories(${target}
        PRIVATE
          ${PROJECT_SOURCE_DIR}/include
          ${CMAKE_CURRENT_SOURCE_DIR}
          ${PROJECT_SOURCE_DIR}/test
      )

      target_link_libraries(${target}
          maliput::common
          maliput::math
          maliput::test_utilities
          maliput_sparse::geometry
      )

    endif()
endmacro()

add_dependencies_to_test(lane_geometry_test)
add_dependencies_to_test(line_string_test)
add_dependencies_to_test(geometry_test)

=== debian/changelog ===
ros-foxy-maliput-sparse (0.2.3-1focal) focal; urgency=high

  * Relies on GetClosestPoint for the GetClosestPointUsing2dProjection method. (#53 <https://github.com/maliput/maliput_sparse/issues/53>)
  * Stores linestring's points in a kdtree. (#52 <https://github.com/maliput/maliput_sparse/issues/52>)
  * Precomputes linestring's segments intervals (#51 <https://github.com/maliput/maliput_sparse/issues/51>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Wed, 15 Feb 2023 03:00:00 -0000

ros-foxy-maliput-sparse (0.2.2-1focal) focal; urgency=high

  * Fixes bug due to segments with zero length. (#49 <https://github.com/maliput/maliput_sparse/issues/49>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Fri, 06 Jan 2023 03:00:00 -0000

ros-foxy-maliput-sparse (0.2.1-1focal) focal; urgency=high

  * Implements range validator for the geometry::utils methods. (#48 <https://github.com/maliput/maliput_sparse/issues/48>)
  * Uses the closest point to calculate the equivalent p in a boundary. (#46 <https://github.com/maliput/maliput_sparse/issues/46>)
  * Adds a adjacency checker for the builder. (#45 <https://github.com/maliput/maliput_sparse/issues/45>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Wed, 04 Jan 2023 03:00:00 -0000

ros-foxy-maliput-sparse (0.2.0-1focal) focal; urgency=high

  * Builds up RoadGeometry out of parsed information. (#40 <https://github.com/maliput/maliput_sparse/issues/40>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Mon, 12 Dec 2022 03:00:00 -0000

ros-foxy-maliput-sparse (0.1.0-1focal) focal; urgency=high

  * Improves documentation. (#43 <https://github.com/maliput/maliput_sparse/issues/43>)
  * Uses RangeValidator within LaneGeometry. (#42 <https://github.com/maliput/maliput_sparse/issues/42>)
  * Supports superelevation. (#38 <https://github.com/maliput/maliput_sparse/issues/38>)
  * Supports passing custom centerline to the lane. (#37 <https://github.com/maliput/maliput_sparse/issues/37>)
  * Fixes minor warning. (#36 <https://github.com/maliput/maliput_sparse/issues/36>)
  * Update triage.yml (#35 <https://github.com/maliput/maliput_sparse/issues/35>)
  * Overrides pendings RoadGeometry methods. (#29 <https://github.com/maliput/maliput_sparse/issues/29>)
  * Builder for BranchPoints (#24 <https://github.com/maliput/maliput_sparse/issues/24>)
  * Adds compare method for the LineStrings. (#28 <https://github.com/maliput/maliput_sparse/issues/28>)
  * Lane::DoEvalMotionDerivatives. (#27 <https://github.com/maliput/maliput_sparse/issues/27>)
  * Implements do_segment_bounds and DoToSegmentPositionBackend. (#23 <https://github.com/maliput/maliput_sparse/issues/23>)
  * Builder API for the RoadGeometry (#11 <https://github.com/maliput/maliput_sparse/issues/11>)
  * Implements Lane::DoToLanePositionBackend. (#22 <https://github.com/maliput/maliput_sparse/issues/22>)
  * Adds r-bounds computations. (#19 <https://github.com/maliput/maliput_sparse/issues/19>)
  * Adds a base class for RoadGeometry. (#21 <https://github.com/maliput/maliput_sparse/issues/21>)
  * Expose lane_geometry header file as it is required by the builder API. (#20 <https://github.com/maliput/maliput_sparse/issues/20>)
  * Adds Lane and implements LaneGeometry::WDot and LaneGeometry::WInverse. (#13 <https://github.com/maliput/maliput_sparse/issues/13>)
  * Adds LaneGeometry class. (#8 <https://github.com/maliput/maliput_sparse/issues/8>)
  * Rename maliput_sample folder to maliput_sparse. (#12 <https://github.com/maliput/maliput_sparse/issues/12>)
  * Adds method for computing the centerline. (#9 <https://github.com/maliput/maliput_sparse/issues/9>)
  * Adds LineString (#4 <https://github.com/maliput/maliput_sparse/issues/4>)
  * Initial project skeleton. (#2 <https://github.com/maliput/maliput_sparse/issues/2>)
  * Contributors: Agustin Alba Chicar, Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Mon, 28 Nov 2022 03:00:00 -0000

=== debian/control ===
Source: ros-foxy-maliput-sparse
Section: misc
Priority: optional
Maintainer: Daniel Stonier <daniel.stonier@tri.global>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake, ros-foxy-ament-cmake-clang-format <!nocheck>, ros-foxy-ament-cmake-gmock <!nocheck>, ros-foxy-ament-cmake-gtest <!nocheck>, ros-foxy-maliput, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-maliput-sparse
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-maliput, ros-foxy-ros-workspace
Description: Maliput sparse is a maliput backend built on top of waypoints without any analytical model of the surface

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-maliput-sparse//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
